﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading;

namespace Communication
{
    public class UART
    {
        private const int THR = 0x03F8;
        private const int IER = 0x03F9;
        private const int IIR = 0x03FA;
        private const int LCR = 0x03FB;
        private const int MCR = 0x03FC;
        private const int LSR = 0x03FD;
        private const int MSR = 0x03FE;
        
        public void Init()                                              //inicializacia seriovej linky
        {
            PortAccess.Out(LCR, 0x80);
            PortAccess.Out(THR, 0x0C);
            PortAccess.Out(IER, 0x00);
            PortAccess.Out(LCR, 0x03);
        }

        public byte ReadByte()                                          //vyberie data z prijimacieho buffra
        {
            return PortAccess.In(THR);
        }

        public void SendByte(byte data)                                 //vysle jeden byte po seriovej linke      
        {
            PortAccess.Out(THR, (int)data);
        }

        public bool ByteSent()                                          //vrati true ak boli data vyslane a vysielaci buffer je prazdny
        {
            bool flag = false;
            if ((PortAccess.In(LSR) & 0x40) != 0) flag = true;
            return flag;
        }
    }

    public class PortAccess
    {
        [DllImport("inpout32.dll", EntryPoint = "Out32")]
        public static extern void Out(int address, int value);

        [DllImport("inpout32.dll", EntryPoint = "Inp32")]
        public static extern byte In(int address);
    }
}
