
#include <absacc.h>
#include "reg552.h"
#include "MSS552.h"

unsigned char TxData = 0, RxData;

void main(void)
{
	//Inicializacia
	Disp_Init();
	Timer0_Init();
	UART_Init();
	
	//globalne povolenie prerusenia
	EA = 1; 
	
	//Hlavny program
	while(1)
	{
		TxData = AD_Read(0) >> 2;
		while(!TI);	TI = 0;														//caka kym bude vysielaci register prazdny
		S0BUF = TxData;
		
		if(TL1) Disp_Int(TxData);
		else		Disp_Int(RxData);											//vypisanie premennej na displej
		
		DelayMs(50);
	}
}

/****** Obsluzny program prerusenia TIM0 ******/
void TIM0_Interrupt(void) interrupt 1
{
	TL0 = 0x00;
	TH0 = 0xFE;
	
	if(RI)																			//ak boli prijate data tak ich spracuj
	{
		RxData = S0BUF;														//prijmi data
		RI = 0;																		//vynuluj priznak prijatych dat
	}
	
	Disp_Handle();		//obnova displeja
}
